<?php
/***************************************************************
 * Copyright notice
 *
 * (c) 2012 - 2013 Michael Staatz <mstaatz@me.com>
 * All rights reserved
 *
 * This script is part of the TYPO3 project. The TYPO3 project is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 *
 * This script is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * class for tce main hooks
 *
 */
class tx_tcemain_hooks {
	/**
	 * Converting markdown to html on saving
	 *
	 * @param array $incommingFieldArray (reference) The field array of a record
	 * @param string $table The table currently processing data for
	 * @param string $id The record uid currently processing data for, [integer] or [string] (like 'NEW...')
	 * @param object $pObj When using TYPO3 CMS >= 6.0.0 => TYPO3\CMS\Core\DataHandling\DataHandler
	 *                     When using TYPO3 CMS < 6.0.0 => t3lib_TCEmain
	 * @return void
	 */
	public function processDatamap_preProcessFieldArray(&$incomingFieldArray, $table, $id, $pObj) {
		if ($incomingFieldArray['CType'] == 'markdown_content_pi1') {
			require_once(t3lib_extMgm::extPath('markdown_content') . 'hooks/reload_markdown_files/class.tx_reload_markdown_files.php');
			$parser = t3lib_div::makeInstance('tx_reload_markdown_files');
			$incomingFieldArray['bodytext'] = $parser->generateMarkdownFromIncludeFile($incomingFieldArray['tx_markdown_content']);
			if (empty($incomingFieldArray['bodytext'])) {
				$incomingFieldArray['bodytext'] = Markdown($incomingFieldArray['tx_markdown_content']);
			}
		}
	}
}

?>